<?php

	// Perform Login
    $CURRENT_MODULE_KEY = 'record_pos_sale_list';
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, $CURRENT_MODULE_KEY);
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_REC_POSSALE_LIST_ID',
							'PARAM_REC_POSSALE_LIST_REC_POSSALE_ID', 
							'PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID', 
							'PARAM_REC_POSSALE_LIST_CAT_UOM_ID', 
							'PARAM_REC_POSSALE_LIST_AMOUNT_PRICE', 
							'PARAM_REC_POSSALE_LIST_AMOUNT_VAT', 
							'PARAM_REC_POSSALE_LIST_QUANTITY', 
							'PARAM_REC_POSSALE_LIST_QUANTITY_PCS', 
							'PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID', 
							'PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL', 
							'PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT', 
							'PARAM_REC_POSSALE_LIST_TOPAY_VATABLE', 
							'PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT', 
							'PARAM_REC_POSSALE_LIST_TOPAY_NONVAT', 
							'PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED', 
							'PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER', 
							'PARAM_REC_POSSALE_LIST_TOPAY_VAT', 
							'PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS', 
							'PARAM_REC_POSSALE_LIST_POINTS', 
							'PARAM_REC_POSSALE_LIST_STATUS'
							// , 'PARAM_REC_POSSALE_LIST_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_POSSALE_LIST_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_POSSALE_LIST_ID', true);
			$PARAM_REC_POSSALE_LIST_REC_POSSALE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_POSSALE_LIST_REC_POSSALE_ID', true);
			$PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID', true);
			$PARAM_REC_POSSALE_LIST_CAT_UOM_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_POSSALE_LIST_CAT_UOM_ID', true);
			$PARAM_REC_POSSALE_LIST_AMOUNT_PRICE = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_AMOUNT_PRICE', true);
			$PARAM_REC_POSSALE_LIST_AMOUNT_VAT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_AMOUNT_VAT', true);
			$PARAM_REC_POSSALE_LIST_QUANTITY = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_QUANTITY', true);
			$PARAM_REC_POSSALE_LIST_QUANTITY_PCS = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_QUANTITY_PCS', true);
			$PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_VATABLE = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_VATABLE', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_NONVAT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_NONVAT', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_VAT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_VAT', true);
			$PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS', true);
			$PARAM_REC_POSSALE_LIST_POINTS = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_POSSALE_LIST_POINTS', true);
			$PARAM_REC_POSSALE_LIST_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_POSSALE_LIST_STATUS', true);
			
			//$PARAM_REC_POSSALE_LIST_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_REC_POSSALE_LIST_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_REC_POSSALE_LIST_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_REC_POSSALE_LIST_ID,
							$PARAM_REC_POSSALE_LIST_REC_POSSALE_ID, 
							$PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID, 
							$PARAM_REC_POSSALE_LIST_CAT_UOM_ID, 
							$PARAM_REC_POSSALE_LIST_AMOUNT_PRICE, 
							$PARAM_REC_POSSALE_LIST_AMOUNT_VAT, 
							$PARAM_REC_POSSALE_LIST_QUANTITY, 
							$PARAM_REC_POSSALE_LIST_QUANTITY_PCS, 
							$PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID, 
							$PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL, 
							$PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT, 
							$PARAM_REC_POSSALE_LIST_TOPAY_VATABLE, 
							$PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT, 
							$PARAM_REC_POSSALE_LIST_TOPAY_NONVAT, 
							$PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED, 
							$PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER, 
							$PARAM_REC_POSSALE_LIST_TOPAY_VAT, 
							$PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS, 
							$PARAM_REC_POSSALE_LIST_POINTS, 
							$PARAM_REC_POSSALE_LIST_STATUS
							// ,$PARAM_REC_POSSALE_LIST_ID_FILE['name']
					]
			);
			

			// Abort if already processed
			// ------------------------------------------------------------------
			$PARAM_REQUEST_UNIQUE_VALUE = null;
			if(PHPRC_HTTP_PARAM::REF_ISSET('PARAM_REQUEST_UNIQUE_VALUE'))
			{
			    $PARAM_REQUEST_UNIQUE_VALUE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REQUEST_UNIQUE_VALUE', false);
			}
			
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
			    $ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY);
			    if
			    (
			        $ARR_INDEX !== false &&
			        PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] == $PARAM_REQUEST_UNIQUE_VALUE
			        )
			    {
			        PHPCUS_PARAM::CUS_JSON_ERROR('Given Request is already processed.');
			    }
			}
			
			
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_RECORD_POS_SALE_LIST::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_ID'] = $PARAM_REC_POSSALE_LIST_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_REC_POSSALE_ID'] = $PARAM_REC_POSSALE_LIST_REC_POSSALE_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID'] = $PARAM_REC_POSSALE_LIST_CAT_PRODUCT_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_CAT_UOM_ID'] = $PARAM_REC_POSSALE_LIST_CAT_UOM_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_AMOUNT_PRICE'] = $PARAM_REC_POSSALE_LIST_AMOUNT_PRICE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_AMOUNT_VAT'] = $PARAM_REC_POSSALE_LIST_AMOUNT_VAT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_QUANTITY'] = $PARAM_REC_POSSALE_LIST_QUANTITY[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_QUANTITY_PCS'] = $PARAM_REC_POSSALE_LIST_QUANTITY_PCS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID'] = $PARAM_REC_POSSALE_LIST_CAT_DISCOUNT_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL'] = $PARAM_REC_POSSALE_LIST_TOPAY_SUBTOTAL[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT'] = $PARAM_REC_POSSALE_LIST_TOPAY_DISCOUNT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_VATABLE'] = $PARAM_REC_POSSALE_LIST_TOPAY_VATABLE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT'] = $PARAM_REC_POSSALE_LIST_TOPAY_VATEXEMPT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_NONVAT'] = $PARAM_REC_POSSALE_LIST_TOPAY_NONVAT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED'] = $PARAM_REC_POSSALE_LIST_TOPAY_ZERORATED[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER'] = $PARAM_REC_POSSALE_LIST_TOPAY_VATOTHER[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_VAT'] = $PARAM_REC_POSSALE_LIST_TOPAY_VAT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS'] = $PARAM_REC_POSSALE_LIST_TOPAY_VAT_LESS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_POINTS'] = $PARAM_REC_POSSALE_LIST_POINTS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_POSSALE_LIST_STATUS'] = $PARAM_REC_POSSALE_LIST_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_RECORD_POS_SALE_LIST::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_FILEDIR_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/pos_sale_list');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/pos_sale_list/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000));
					
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_REC_POSSALE_LIST_ID_FILE['tmp_name'][$ARRAY_CTR],
							PHPSET::$ROOT . '/upload/priv/Record/pos_sale_list/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000) . '/' . $DATA_SET[0]['INSERTED_ID'] . '.' .
							PHPVC_STR::VAR_LCASE(PathInfo($PARAM_REC_POSSALE_LIST_ID_FILE['name'][$ARRAY_CTR], PATHINFO_EXTENSION))
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			// Update processed request key
			// ------------------------------------------------------------------
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
			    $ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY);
			    if($ARR_INDEX !== false)
			    {
			        PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] = $PARAM_REQUEST_UNIQUE_VALUE;
			    }
			    else
			    {
			        array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY, $CURRENT_MODULE_KEY);
			        array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE, $PARAM_REQUEST_UNIQUE_VALUE);
			    }
			}	
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>